.686			
.XMM
.model 	flat, stdcall
option 	casemap:none

include	c:\masm32\include\windows.inc
include	c:\masm32\include\kernel32.inc
include	c:\masm32\include\masm32.inc
include	c:\masm32\macros\macros.asm
include	c:\masm32\macros\timers.asm
includelib	c:\masm32\lib\kernel32.lib
includelib	c:\masm32\lib\masm32.lib

Main				proto


lingo32				proto
lostcauz32        proto 


.data

	LOOP_COUNT	EQU	10000000		; 1M iterations per timing result

    align 4
	  str1 db 'abcdefghijklmnopqrstuvwxyzabc',0
      str2 db 64 dup(0)
      str3 db 64 dup(0) 


msgstr db "Cycles: %d", 0
Strlingo					DB  "ReverseStr - lingo     : ",0
Strlostcauz				DB  "ReverseStr - lostcauz  : ",0
 retva  dd 0


.data?
    buff db 32 dup(?)



.code
Start:
	Invoke	Main
	Invoke	ExitProcess, 0
Main	Proc
	;print	chr$(" ReverseStr tests ",13,10)
	mov	eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    	print	chr$(13,10,13,10," ReverseStr  Tests:",13,10,13,10)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  

; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment * ReverseStr by lostcauz *
	print	addr Strlostcauz
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
		call lostcauz32 
	;	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks  ")
	;mov	eax, retva
	;print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250

; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
	
comment * ReverseStr by lingo *
	print	addr Strlingo
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
		call Lingo32
	;	mov	retva, eax
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks ")
	;mov	eax, retva
	;print	ustr$(eax)
	print	chr$(" ",13,10)
	invoke	Sleep, 250
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  


	mov	eax, input(13,10," Press ENTER to exit...")
	ret
Main	EndP


; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment 		* ReverseStr by lostcauz *
align 		16
;##########################################################################
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
lostcauz32 proc
    lea esi,str1            ; load effective address of string 
    lea edi,str3            ; load effective address of buffer
    mov ecx,[sizeof str1-1] ; determine length of string less terminating '0'
    mov ebx,ecx             ; load length for manipulation
    cmp ecx,4               ; ensure string is large enough for dword manipulations
    jb l1                   ; if not, work with one byte at a time
    and ebx,3               ; test dword alignment by checking two least significant bytes
    jz l2                   ; if zero it's 4 byte aligned
    cmp ebx,3               ; test if both lsb's set
    jnz @f                  ; next test
    sub ecx,1               ; both lsb's are set, work byte by byte until dword aligned
    mov al,[esi+ecx]        ; load last character
    sub ebx,1               ; decrement for next test
    mov [edi],al            ; save byte to beginning of buffer
    add edi,1               ; increment buffer position for next byte

@@: cmp ebx,2               ; test only bit 1
    jnz @f                  ; next test
    sub ecx,1               ; decrement string position
    mov al,[esi+ecx]        ; load byte
    sub ebx,1               ; prepare for next byte
    mov [edi],al            ; save byte to buffer
    add edi,1               ; increment buffer position

@@: cmp ebx,1               ; test only bit 0
    jnz l1                  ; next
    sub ecx,1               ; update string position
    mov al,[esi+ecx]        ; load byte
    mov [edi],al            ; store to buffer
    add edi,1               ; update buffer position
    jmp l2                  ; move on to dword manipulation
    
l1: sub ecx,1               ; string is less than 4 characters
    mov al,[esi+ecx]        ; load byte
    mov [edi],al            ; store byte
    add edi,1               ; update buffer
    or ecx,ecx              ; last byte?
    jz l3                   ; done
    jmp l1                  ; continue
    
l2: sub ecx,4               ; back up 4 bytes
    jnz @f                  ; if > 0 go to dword loading loop
    mov eax,[esi+ecx]       ; else load the only dword
    bswap eax               ; reverse dword 
    mov [edi],eax           ; load dword
    jmp l3                  ; done
       
@@: mov eax,[esi+ecx]       ; load dword 
    bswap eax               ; swap bytes
    mov [edi],eax           ; store dword
    add edi,4               ; update buffer for next dword
    sub ecx,4               ; back up to next dword
    jnz @b                  ; loop
    mov eax,[esi]           ; load last dword
    bswap eax               ; swap
    mov [edi],eax           ; store and done.  
l3: 
	ret 
lostcauz32 endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
;...........................................................................................
comment * ReverseStr by Lingo *
align	16
db  0A4h, 24h, 0, 0, 0, 0 , 8Dh, 9Bh,  0, 0, 0, 0,90 
Lingo32			proc	
    mov ecx, sizeof str1-1
    xor eax, eax
    cmp ecx, 4
	mov	byte ptr [str2+ecx], al
    jl Bytes3
    push ebx
@@:
    mov edx, dword ptr [str1+eax]
    add eax, 4
    add ecx, -8
    mov ebx, dword ptr [str1+eax+ecx]
    bswap edx
    mov dword ptr [str2+eax +ecx], edx
    bswap ebx
    mov dword ptr [str2+eax-4], ebx
    jg @b
    pop ebx
    ret
align	16
Bytes3:
    movzx edx, byte  ptr [str1]
    cmp ecx, 1
    mov byte ptr [str2+ecx-1], dl
    jle End3
    mov dl, byte  ptr [str1+1]
    cmp ecx, 2
    mov byte ptr [str2+ecx-2], dl
    jle End3
    mov dl, byte  ptr [str1+2]
    mov byte ptr [str2+ecx-3], dl
End3:
	ret
Lingo32			endp		
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

      
End	Start




